var g_socketid = -1;
var g_bluetoothPlugin = null;
var g_uuid = null;

var clockSet = false;

var t0 = 0;
var t1 = 0;
var t2 = 0;
var t3 = 0;
var t4 = 0;
var t5 = 0;
var t6 = 0;

myontecInit(4);


function checkTime(i) {
	if (i<10) i="0"+i;
	return i;
}

function getClock() {
	var today=new Date();
	var y=today.getFullYear()+"";
	var mo=today.getMonth()+1;
	var d=today.getDate();
	mo=checkTime(mo);
	d=checkTime(d);
	var h=today.getHours();
	var m=today.getMinutes();
	var s=today.getSeconds();
	h=checkTime(h);
	m=checkTime(m);
	s=checkTime(s);
	var clock = ""+d+mo+y+h+m+s+"00";
	// alert(clock);
	
	return clock;
}

function syncClock() {
	writeCommandRfcomm("rtcwrite"+getClock());
}

window.addEventListener('load', function () {
    
	document.addEventListener('deviceready', function () {
        $('#debug').html("Platform is now ready!");
		g_bluetoothPlugin = cordova.require( 'cordova/plugin/bluetooth' );
		if(window.localStorage.getItem("bt-device-text") != null && window.localStorage.getItem("bt-device-val") != null) {
			$('#bt-devices-select').append( $( '<option value="' + window.localStorage.getItem("bt-device-val") + '">' + window.localStorage.getItem("bt-device-text") + '</option>' ) );
			// $('#debug').html("Platform is now ready, now searching old device connections...");
			// setTimeout(loadOldConnection, 1000);
		}
		myontecInitialize();
    }, false);
}, false);

function loadOldConnection() {
	
	g_bluetoothPlugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
		// $('#connect').removeAttr("disabled");
		// $('#debug').html("Platform is now ready and one device detected!");
		// setTimeout(listUUIDsAndStart, 200);
		// listUUIDs();
	}, function(error) {
		$('#debug').html( 'Error loadOldConnection: ' + error );
	} );
}

function enableBT() {
	$('#debug').html( "enableBT" );
	g_bluetoothPlugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
		// discoverDevices();
	}, function(error) {
		$('#debug').html( 'Error enabling BT: ' + error );
	} );
}

function enableAndDiscoverBT() {
	$('#debug').html( "enableBT" );
	g_bluetoothPlugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
		discoverDevices();
	}, function(error) {
		$('#debug').html( 'Error enabling BT: ' + error );
	} );
}

function disconnectBT() {
	$('#debug').html( "disconnectBT" );
	g_bluetoothPlugin.disconnect( function() {
		g_socketid = -1;
		$('#debug').html( 'Disconnectin successfull' );
		// $('#connect').attr('disabled', 'disabled');
		// $('#disconnect').attr('disabled', 'disabled');
	}, function(error) {
		$('#debug').html( 'Error disabling BT: ' + error );
	} );
}

function disableBT() {
	$('#debug').html( "disableBT" );
	g_bluetoothPlugin.disable( function() {
		g_socketid = -1;
		$('#debug').html( 'Disabling successfull' );
		// $('#connect').attr('disabled', 'disabled');
		// $('#disconnect').attr('disabled', 'disabled');
	}, function(error) {
		$('#debug').html( 'Error disabling BT: ' + error );
	} );
}

function discoverDevices() {
    // $('#debug').html("Please wait, discovering devices and it may takes over 10 seconds...");
	showDialog("Please wait", "Discovering Bluetooth devices. Please wait...", 0);
	$('#bt-devices-select').html('');
	// $('#connect').html("Connect");
	// $('#connect').attr('disabled', 'disabled');
	// $('#btn-start').attr('disabled', 'disabled');
	// $('#btn-pause').attr('disabled', 'disabled');
	// $('#btn-stop').attr('disabled', 'disabled');
	// $('#btn-clear').attr('disabled', 'disabled');
	g_bluetoothPlugin.discoverDevices( function(devices) {
		$('#bt-devices-select').html('');
    	
		var arr = new Array();
		var j = 0;
    	for( var i = 0; i < devices.length; i++ ) {
    		// $('#bt-devices-select').append( $( '<option value="' + devices[i].address + '">' + devices[i].name + '</option>' ) );
			if(devices[i].name.indexOf("MbM") == 0) {
				arr[j++] = devices[i].address + ';' + devices[i].name;
				
				useMbody = true;
				useBT4 = false;
				document.getElementById("use-mbody").className = "useYellow";
				window.localStorage.setItem("myontec-use-mbody", "1");
				window.localStorage.setItem("myontec-use-bt4", "");
			}
    	}
		// $('#connect').removeAttr("disabled");
		// $('#debug').html("Devices detected!");
		// showDialog("Please wait", "Devices detected!", 3000);
		showBluetoothDialog(arr);
    }, function(error) { /* $('#debug').html( 'Error: ' + error ); */ showDialog("Please wait", 'Error: ' + error, 10000);} );
}

function listUUIDs() {
	$('#debug').html("Please wait, connecting to device...");
	mbodyStatus = 1;
	g_bluetoothPlugin.getUUIDs( function(uuids) {
		// $('#bt-device-uuids').html('');
		
		var str = "";
		for( var i = 0; i < uuids.length; i++ ) {
			// $('#bt-device-uuids').append( $( '<option value="' + uuids[i] + '">' + uuids[i] + '</option>' ) );
			str += uuids[i] + " ";
		}
		// $('#debug').html('uuids ['+uuids.length+']: '+str+', ');
		
		if( uuids.length > 0 ) {
			g_bluetoothPlugin.connect( function(socketId) { 
				g_socketid = socketId; 
				console.log( 'Socket-id: ' + g_socketid ); 
				// $('#btn-start').removeAttr("disabled");
				mbodyStatus = 0;
				$('#debug').html("Device connected!");
				// $('#connect').html("Connected");
				// $('#disconnect').removeAttr("disabled");
				frameOn();
			}, function(error) { /* alert( 'Error: ' + error ); */ $('#debug').html('Error: ' + error); mbodyStatus = 0; }, $( '#bt-devices-select' ).val(), uuids[0] );
		}
	}, function(error) { $('#debug').html( 'Error: ' + error ); mbodyStatus = 0; }, $( '#bt-devices-select' ).val() );
	window.localStorage.setItem("bt-device-text", $( '#bt-devices-select :selected' ).text());
	window.localStorage.setItem("bt-device-val", $( '#bt-devices-select' ).val());
}

function listUUIDsAndStart() {
	$('#debug').html("Please wait, connecting to device...");
	mbodyStatus = 1;
	g_bluetoothPlugin.getUUIDs( function(uuids) {
		// $('#bt-device-uuids').html('');
		
		var str = "";
		for( var i = 0; i < uuids.length; i++ ) {
			// $('#bt-device-uuids').append( $( '<option value="' + uuids[i] + '">' + uuids[i] + '</option>' ) );
			str += uuids[i] + " ";
		}
		// $('#debug').html('uuids ['+uuids.length+']: '+str+', ');
		
		if( uuids.length > 0 ) {
			g_bluetoothPlugin.connect( function(socketId) { 
				mSaveStart = new Date().getTime();
				g_socketid = socketId; 
				console.log( 'Socket-id: ' + g_socketid ); 
				// $('#btn-start').removeAttr("disabled");
				mbodyStatus = 0;
				$('#debug').html("Device connected!");
				// $('#connect').html("Connected");
				// $('#disconnect').removeAttr("disabled");
				if(!clockSet) {
					// rtcwriteddMMyyyyHHmmssDD 1511201310193000
					// alert(getClock());
					// writeCommandRfcomm("rtcwrite"+getClock());
					clockSet = true;
					setTimeout(writeClock, 200);
					// setTimeout(syncClock, 200);
					// setTimeout(writeCommandRfcommOM4, 600);
				} else {
					setTimeout(writeCommandRfcommOM4, 200);
				}
			}, function(error) { /* alert( 'Error: ' + error ); */ $('#debug').html('Error listUUIDsAndStart: ' + error); mbodyStatus = 0; if(g_socketid >= 0) {setTimeout(writeCommandRfcommOM4, 200);} }, $( '#bt-devices-select' ).val(), uuids[0] );
		}
	}, function(error) { $('#debug').html( 'Error: ' + error ); mbodyStatus = 0; }, $( '#bt-devices-select' ).val() );
	window.localStorage.setItem("bt-device-text", $( '#bt-devices-select :selected' ).text());
	window.localStorage.setItem("bt-device-val", $( '#bt-devices-select' ).val());
}

function writeClock() {
	// $('#debug').html( "Writing '" + cmd + "'" );
	// showDialog("Mbody Live", "writeClock...", 1000);
	g_bluetoothPlugin.write( bp_readClockSuccess, bp_readClockError, g_socketid, "rtcwrite"+getClock() );
}

function bp_readClockError( error ) {
	$('#debug').html( 'Error: ' + error );
	// showDialog("Mbody Live", "bp_readClockError... "+error, 1000);
	// setTimeout(writeCommandRfcommOM4, 600);
}

function bp_readClockSuccess( p_data ) {
	// showDialog("Mbody Live", "bp_readClockSuccess... ", 1000);
	setTimeout(writeCommandRfcommOM4, 200);
}

function openRfcomm() {
	$('#debug').html( "Opening..." );
	g_bluetoothPlugin.connect( function(socketId) { 
		g_socketid = socketId;
		console.log( 'Socket-id: ' + g_socketid );
	}, function(error) { $('#debug').html( 'Error: ' + error ); }, $( '#bt-devices-select' ).val(), $( '#bt-device-uuids' ).val() );
}

function writeRfcomm() {
	$('#debug').html( "Writing '" + $( '#bt-device-txt' ).val() + "'" );
	g_bluetoothPlugin.write( bp_readSuccess, bp_readError, g_socketid, $( '#bt-device-txt' ).val() );
}

var lastOM4 = 0;
function writeCommandRfcommOM4() {
	var now = new Date().getTime();
	if((now-lastOM4)/1000 >= 2) {
		var cmd = "om4";
		$('#debug').html( "Writing '" + cmd + "'" );
		g_bluetoothPlugin.write( bp_readSuccess, bp_readError, g_socketid, cmd );
		setTimeout(myontecLoop, 400);
		lastOM4 = now;
	}
}

function writeCommandRfcomm(cmd) {
	$('#debug').html( "Writing '" + cmd + "'" );
	g_bluetoothPlugin.write( bp_readSuccess, bp_readError, g_socketid, cmd );
}

function writeNowRfcomm() {
	$('#debug').html( "Writing '" + $( '#bt-device-txt' ).val() + "'" );
	g_bluetoothPlugin.writenow( bp_readSuccess, bp_readError, $( '#bt-devices-select' ).val(), $( '#bt-device-uuids' ).val(), $( '#bt-device-txt' ).val() );
}

function readRfcomm() {
	$('#debug').html( "Reading..." );
	g_bluetoothPlugin.read( bp_readSuccess, bp_readError, g_socketid );
}

function readHexRfcomm() {
	// $('#debug').html( "readRfcomm" );
	t1 = new Date().getTime();
	g_bluetoothPlugin.readhex( bp_readHexSuccess, bp_readError, g_socketid );
}

function readNowRfcomm() {
	$('#debug').html( "Reading now..." );
	g_bluetoothPlugin.readnow( bp_readSuccess, bp_readError, $( '#bt-devices-select' ).val(), $( '#bt-device-uuids' ).val() );
}

function bp_readError( error ) {
	$('#debug').html( 'Error: ' + error );
}

function bp_readSuccess( p_data ) {
	$('#debug').html( p_data );
}

var missedData = "";
var missedCount = 0;
function bp_readHexSuccess( p_data ) {
	// $('#debug').html( p_data );
	t2 = new Date().getTime();
	if(missedCount > 0 && missedData != "") { // jariha 2.3.2014
		if(missedCount > 2) {
			var str = "";
			if(mStamp == "") { // jariha 3.6.2014
				myontecData(missedData.trim().split(" "));
				str = "Data {"+missedData+"} readed "+missedData.trim().split(" ").length+" bytes.\n";
			} else {
				str = "Missed {"+missedData+"} readed "+missedData.trim().split(" ").length+" bytes.\n";
			}
			filewriteappend_debugdata(mSaveStamp, str);
			missedCount = 0;
		} else {
			p_data = missedData + p_data;
		}
		missedData = "";
	}
	/* if(p_data.indexOf(" 00 00 01 2f") >= 0) { // jariha 3.6.2014
		if(p_data.indexOf(" 00 00 01 2f") = 0) p_data = p_data.substring(p_data.indexOf(" 00 00 01 2f"));
		missedCount = 0;
		myontecData(p_data.trim().split(" "));
		t3 = new Date().getTime();
		// myontecPrint();
		t5 = new Date().getTime();
		// $('#debug').html("Data "+rawData.length+" readed "+p_data.split(" ").length+" bytes. Times "+(t1-t0)+" / "+(t2-t1)+" + "+(t3-t2)+" / "+(t4-t3)+" + "+(t5-t4)+" ms");
		var str = "Header {"+p_data+"} readed "+p_data.trim().split(" ").length+" bytes.\n";
		t6 = t5;
		filewriteappend_debugdata(mSaveStamp, str);
		$('#debug').html("");
	} else */ if(mStamp == "" || p_data.trim().split(" ").length % 8 == 0) {
		missedCount = 0;
		myontecData(p_data.trim().split(" "));
		t3 = new Date().getTime();
		// myontecPrint();
		t5 = new Date().getTime();
		// $('#debug').html("Data "+rawData.length+" readed "+p_data.split(" ").length+" bytes. Times "+(t1-t0)+" / "+(t2-t1)+" + "+(t3-t2)+" / "+(t4-t3)+" + "+(t5-t4)+" ms");
		var str = "Data {"+p_data+"} readed "+p_data.trim().split(" ").length+" bytes. Times i"+(t1-t0)+" + r"+(t2-t1)+" + h"+(t3-t2)+" + d"+(t5-t3)+" = "+(t5-t1)+" ("+(t5-t6)+") ms\n";
		t6 = t5;
		filewriteappend_debugdata(mSaveStamp, str);
		$('#debug').html("");
	} else {
		t3 = new Date().getTime();
		// myontecPrint();
		t5 = new Date().getTime();
		var tmpData = p_data;
		missedData += p_data;
		missedCount++;
		var str = "Stored "+mSaveStamp+" {"+tmpData+"} readed "+tmpData.trim().split(" ").length+" bytes. Times i"+(t1-t0)+" + r"+(t2-t1)+" + h"+(t3-t2)+" + d"+(t5-t3)+" = "+(t5-t1)+" ("+(t5-t6)+") ms\n";
		t6 = t5;
		filewriteappend_debugdata(mSaveStamp, str);
		$('#debug').html("");
	}
	
	if(mRunning) {
		t0 = new Date().getTime();
		setTimeout(myontecLoop, 100);
	}
}