/* var g_filesystemPlugin = null;

window.addEventListener('load', function () {
    
	document.addEventListener('deviceready', function () {
        $('#debug').html("Platform FS is now ready!");
		g_filesystemPlugin = cordova.require( 'cordova/plugin/filesystem' );
    }, false);
}, false); */


var fileSystem = null;

// Wait for device API libraries to load
//
document.addEventListener("deviceready", onDeviceReady, false);

// device APIs are available
//
function onDeviceReady() {
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, fail);
}

function gotFS(fs) {
    fileSystem = fs;
    createdir("myontec");
	filewrite("debug.txt", createStamp()+"\n", doNothing);
}

function fail(error) {
    console_log("filesystem: "+error);
}

function fileread_history() {
	/*
     // $('#debug').html( "fileread history" );
	try {
		g_filesystemPlugin.filedirectory( function(filedata) {
			// $('#debug').html( 'fileread history successfull' );
			// alert(filedata);
			historyFiles = new Array();
			historyFileSizes = new Array();
			historyFileJson = new Array();
			if(filedata != "") {
				var values = filedata.split(";");
				var d = 0;
				for(var i = 0; i < values.length; i++) {
					if(values[i] != "") {
						var data = values[i].split("/");
						if(data[0] != "") {
							var stamp = data[0].replace("data_", "").replace(".txt", "");
							stamp = stamp.substring(0, 4)+"-"+stamp.substring(4, 6)+"-"+stamp.substring(6, 8)+" "+stamp.substring(9, 11)+":"+stamp.substring(11, 13)+":"+stamp.substring(13, 15);
							historyFiles[d] = stamp;
							historyFileSizes[d] = data[1];
							historyFileJson[d] = data[2];
							d++;
						}
					}
				}
			}
		}, function() {
			$('#debug').html( 'Error fileread history: ' + error );
			// alert(error);
		} );
	} catch(err) {
		// alert(err);
	}
     */
    historyFiles = new Array();
    historyFileSizes = new Array();
    historyFileJson = new Array();
    
	if(fileSystem) {
		fileSystem.root.getDirectory("myontec/", {create: false, exclusive: false}, function(dirEntry) {
			 
			 // var dirReader = fileSystem.root.createReader();
			 var dirReader = dirEntry.createReader();
			 
			 // Call the reader.readEntries() until no more results are returned.
			 var readEntries = function() {
			 dirReader.readEntries (function(results) {
					if (!results.length) {
						// listResults(entries.sort());
					} else {
						// entries = entries.concat(toArray(results));
						results.forEach(function(entry, i) {
						// alert("file: "+entry.name);
						
						if(entry.name.indexOf("data_") == 0 && entry.name.indexOf(".txt") > 0) {
													var stamp = entry.name.replace("data_", "").replace(".txt", "");
													stamp = stamp.substring(0, 4)+"-"+stamp.substring(4, 6)+"-"+stamp.substring(6, 8)+" "+stamp.substring(9, 11)+":"+stamp.substring(11, 13)+":"+stamp.substring(13, 15);
													historyFiles[historyFiles.length] = stamp;
													}
													});
									readEntries();
									}
									}, fail);
			 };
			 
			 readEntries(); // Start reading dirs.
			 
			 }, fail);
	}
}

function filewriteappend_debugdata(stamp, data) {
	/*
     // $('#debug').html( "Please wait, writing history file..." );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	// alert("myontec-file_"+fname+".txt "+ data);
	g_filesystemPlugin.fileappend( function() {
		// $('#debug').html( 'filewrite history successfull' );
	}, function() {
		$('#debug').html( 'Error fileappend history: ' + error );
	}, "debug_"+fname+".txt", data );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filewriteappend("debug_"+fname+".txt", data, doNothing);
}

function filewritenow_historydata(stamp, data) {
	/*
     // $('#debug').html( "Please wait, writing history file..." );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.filewrite( function() {
		// $('#debug').html( 'filewrite history successfull' );
		getHistory();
	}, function() {
		$('#debug').html( 'Error filewrite history: ' + error );
	}, "data_"+fname+".txt", data );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filewrite("data_"+fname+".txt", data, getHistory);
}

function filewriteappend_historydata(stamp, data) {
	/*
     // $('#debug').html( "Please wait, writing history file..." );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	// alert("myontec-file_"+fname+".txt "+ data);
	g_filesystemPlugin.fileappend( function() {
		// $('#debug').html( 'filewrite history successfull' );
	}, function() {
		$('#debug').html( 'Error fileappend history: ' + error );
	}, "data_"+fname+".txt", data );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filewriteappend("data_"+fname+".txt", data, doNothing);
}

function fileread_historydata(stamp) {
	/*
     $('#debug').html( "Please wait, reading history file..." );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.fileread( function(filedata) {
		$('#debug').html( '' );
		myontecHistoryData(filedata);
		myontecPrint();
	}, function() {
		$('#debug').html( 'Error fileread historydata: ' + error );
	}, "data_"+fname+".txt" );
	// }, "myontec_"+athleteName.replace(" ", "-")+"_"+stamp.replace(" ", "_")+".txt" );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    fileread("data_"+fname+".txt", myontecHistoryData, true);
}

function filedelete_historydata(stamp) {
	/*
     // $('#debug').html( "filedelete historydelete" );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.filedelete( function() {
		// $('#debug').html( 'filedelete historydelete successfull..' );
		// getHistory();
		filedelete_historydata2(stamp);
		// filedelete_extradata(stamp);
	}, function() {
		$('#debug').html( 'Error filewrite historydelete: ' + error );
		alert(error);
	}, "data_"+fname+".txt" );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    console_clear();
    console_log("filedelete_historydata "+fname);
    filedelete("data_"+fname+".txt", filedelete_historydata2, stamp);
}

function filedelete_historydata2(stamp) {
	/*
     // $('#debug').html( "filedelete historydelete" );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.filedelete( function() {
		// $('#debug').html( 'filedelete historydelete successfull..' );
		// getHistory();
		filedelete_historydata3(stamp);
		// filedelete_extradata(stamp);
	}, function() {
		$('#debug').html( 'Error filewrite historydelete: ' + error );
		alert(error);
	}, "data_"+fname+".info" );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filedelete("data_"+fname+".info", filedelete_historydata3, stamp);
}

function filedelete_historydata3(stamp) {
	/*
     // $('#debug').html( "filedelete historydelete" );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.filedelete( function() {
		// $('#debug').html( 'filedelete historydelete successfull..' );
		// getHistory();
		filedelete_historydata4(stamp);
		// filedelete_extradata(stamp);
	}, function() {
		$('#debug').html( 'Error filewrite historydelete: ' + error );
		alert(error);
	}, "data_"+fname+".json" );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filedelete("data_"+fname+".json", filedelete_historydata4, stamp);
}

function filedelete_historydata4(stamp) {
	/*
     // $('#debug').html( "filedelete historydelete" );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.filedelete( function() {
		// $('#debug').html( 'filedelete historydelete successfull..' );
		getHistory();
		// filedelete_extradata(stamp);
	}, function() {
		$('#debug').html( 'Error filewrite historydelete: ' + error );
		alert(error);
	}, "debug_"+fname+".txt" );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filedelete("debug_"+fname+".txt", checkfiles, stamp);
}

function filewrite_jsondata(stamp, data) {
	/*
     // $('#debug').html( "Please wait, writing json file..." );
	
	showDialog("Please wait", "Saving JSON file", 20);
	
	// $('#debug').html( "filewrite history" );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	// alert("myontec-file_"+fname+".txt "+ data);
	g_filesystemPlugin.filewrite( function() {
		// $('#debug').html( 'filewrite history successfull' );
		closeDialog();
	}, function() {
		$('#debug').html( 'Error filewrite json: ' + error );
	}, "data_"+fname+".json", data );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filewrite("data_"+fname+".json", data, closeDialog);
}

function filecheck_infodata(stamp) {
	/*
     $('#debug').html( "Please wait, reading info file..." );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.fileread( function(filedata) {
		$('#debug').html( '' );
		myontecCheckInfoData(filedata);
	}, function() {
		$('#debug').html( 'Error fileread infodata: ' + error );
	}, "data_"+fname+".info" );
     */
    /* var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    fileSystem.documents.getFile("myontec_"+fname+"_data.info", {create: true, exclusive: false}, function(fileEntry) {
        fileEntry.createWriter( function(writer) {
            writer.onwrite = function(evt) {
                // console_log("write success");
            };
            writer.write(data+"\n");
        }, fail);
    }, fail); */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    fileread("data_"+fname+".info", myontecCheckInfoData, false);
    
    afterDelayChecked = false;
    afterDelayFunc = myontecCheckInfoData;
    setTimeout(afterDelay, 200);
}

var afterDelayChecked = false;
var afterDelayFunc = null;
function fileread_infodata(stamp) {
	/*
     $('#debug').html( "Please wait, reading info file..." );
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.fileread( function(filedata) {
		$('#debug').html( '' );
		myontecInfoData(filedata);
	}, function() {
		$('#debug').html( 'Error fileread infodata: ' + error );
	}, "data_"+fname+".info" );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    // alert("fileread_infodata "+fname);
    fileread("data_"+fname+".info", myontecInfoData, false);
    
    afterDelayChecked = false;
    afterDelayFunc = myontecInfoData;
    setTimeout(afterDelay, 200);
}
function filewrite_infodata(stamp, data) {
	/*
     // showDialog("Please wait", "Saving info file", 20);
	var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
	g_filesystemPlugin.filewrite( function() {
		closeDialog();
	}, function() {
		$('#debug').html( 'Error filewrite info: ' + error );
	}, "data_"+fname+".info", data );
     */
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filewrite("data_"+fname+".info", data, closeDialog);
}

var infoDataCheck = "";
function filewrite_infodata2(stamp, data) {
    /*
     // showDialog("Please wait", "Saving info file", 20);
     var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
     g_filesystemPlugin.filewrite( function() {
     closeDialog();
     }, function() {
     $('#debug').html( 'Error filewrite info: ' + error );
     }, "data_"+fname+".info", data );
     */
    infoDataCheck = data;
    var fname = stamp.replace(" ", "_").replace(":", "").replace(":", "").replace("-", "").replace("-", "");
    filewrite("data_"+fname+".info", data, afterInfoDataCheck);
}

function filewrite(fname, data, func) {
    // console_log("filewrite: "+fname);
    fileSystem.root.getFile("myontec/"+fname, {create: true, exclusive: false}, function(fileEntry) {
        fileEntry.createWriter( function(writer) {
            writer.onwrite = function(evt) {
                // console_log("write success: "+data);
                func();
            };
            writer.write(data+"\n");
        }, fail);
    }, fail);
}

function filewriteappend(fname, data, func) {
    // console_log("filewriteappend: "+fname);
    fileSystem.root.getFile("myontec/"+fname, {create: true, exclusive: false}, function(fileEntry) {
        fileEntry.createWriter( function(writer) {
            writer.onwrite = function(evt) {
                // console_log("write success: "+data);
                func();
            };
            writer.seek(writer.length);
            writer.write(data+"\n");
        }, fail);
    }, fail);
}

function fileread(fname, func, printAfter) {
    // console_log("fileread: "+fname);
    // console_clear();
    // console_log("fileread: "+fname);
    fileSystem.root.getFile("myontec/"+fname, {}, function(fileEntry) {
        fileEntry.file(function(file) {
            var reader = new FileReader();
            reader.onloadend = function(e) {
                // console_log("read success: "+this.result);
                // alert(this.result);
                afterDelayChecked = true;
                // console_log(this.result.replaceAll("\n", "<br />").replaceAll("<br /><br />", "<br />"));
                func(this.result);
                if(printAfter) myontecPrint();
            };
            reader.readAsText(file);
        }, fail);
    }, fail);
}

function filedelete(fname, func, stamp) {
    // console_log("filedelete: "+fname);
    fileSystem.root.getFile("myontec/"+fname, {create: true, exclusive: false}, function(fileEntry) {
        fileEntry.remove( function() {
                         console_log("file deleted");
                         func(stamp);
        }, fail);
    }, fail);
}

function checkfiles(stamp) {
    getHistory();
}

function afterDelay() {
    if(!afterDelayChecked) {
        afterDelayFunc("");
    }
}

function afterInfoDataCheck() {
    myontecInfoData(infoDataCheck);
}

function createdir(dirname) {
    fileSystem.root.getDirectory(dirname, {create: true}, function(dirEntry) {

    }, fail);
}

function test123(txt, func1) {
    func1(txt);
}

function func123(txt) {
    alert(txt);
}

function doNothing() {
    
}