
var bluetoothserialDevices = new Array();
var connectedAddress = "";

function checkTime(i) {
	if (i<10) i="0"+i;
	return i;
}

function getClock() {
	var today=new Date();
	var y=today.getFullYear()+"";
	var mo=today.getMonth()+1;
	var d=today.getDate();
	mo=checkTime(mo);
	d=checkTime(d);
	var h=today.getHours();
	var m=today.getMinutes();
	var s=today.getSeconds();
	h=checkTime(h);
	m=checkTime(m);
	s=checkTime(s);
	var clock = ""+d+mo+y+h+m+s+"00";
	// alert(clock);
	
	return clock;
}

function bluetoothserial_list() {
	console_log("bluetoothserial_list");
	try {
		// bluetoothserialDevices = new Array();
		bluetoothSerial.list(bluetoothserial_list_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_discover() {
	console_log("bluetoothserial_discover");
	try {
		bluetoothserialDevices = new Array();
		// editorDialog("Discovering Bluetooth devices...", 5000);
		bluetoothSerial.discoverUnpaired(bluetoothserial_discover_success, bluetoothserial_failed);
		// setTimeout(bluetoothserial_list, 4000);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_discover_success(devices) {
    console_log("bluetoothserial_discover_success: ");
	devices.forEach(function(device) {
		console_log(device.name+" : "+device.id);
		if(device.name.indexOf("MbM") == 0 && device.name.indexOf("MbMS") < 0) {
			var alreadyInArray = false;
			for(var i = 0; i < bluetoothserialDevices.length; i++) {
				if(bluetoothserialDevices[i] == device.id + ';' + device.name) {
					alreadyInArray = true;
				}
			}
			if(!alreadyInArray) {
				bluetoothserialDevices[bluetoothserialDevices.length] = device.id + ';' + device.name;
				// showBluetoothserialDialog(bluetoothserialDevices);
			}
		}
	});
	bluetoothserial_list();
}
function bluetoothserial_list_success(devices) {
    console_log("bluetoothserial_list_success: ");
	devices.forEach(function(device) {
		console_log(device.name+" : "+device.id);
		if(device.name.indexOf("MbM") == 0 && device.name.indexOf("MbMS") < 0) {
			var alreadyInArray = false;
			for(var i = 0; i < bluetoothserialDevices.length; i++) {
				if(bluetoothserialDevices[i] == device.id + ';' + device.name) {
					alreadyInArray = true;
				}
			}
			if(!alreadyInArray) {
				bluetoothserialDevices[bluetoothserialDevices.length] = device.id + ';' + device.name;
				// showBluetoothserialDialog(bluetoothserialDevices);
			}
		}
	});
	showBluetoothserialDialog(bluetoothserialDevices);
}

function bluetoothserial_failed(reason) {
	console_log("bluetoothserial_failed: "+reason);
}

function bluetoothserial_start() {
	console_log("bluetoothserial_start");
	if( $( '#bt-devices-select' ).val() != "") {
		bluetoothserial_connect($( '#bt-devices-select' ).val());
	}
}

function bluetoothserial_stop() {
	console_log("bluetoothserial_stop");
	bluetoothserial_disconnect();
}

function bluetoothserial_connect(address) {
	console_log("bluetoothserial_connect "+address);
	try {
		connectedAddress = address;
		bluetoothSerial.connect(address, bluetoothserial_connect_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_connect_success() {
	console_log("bluetoothserial_connect_success");
	
	console_log("bluetoothserial_write rtcwrite"+getClock());
	bluetoothserial_write("rtcwrite"+getClock()+"\r");
	// bluetoothserial_write("fwvers\r");
	setTimeout(bluetoothserial_write_om4, 200);
}

function bluetoothserial_write_om4() {
	console_log("bluetoothserial_write_om4");
	bluetoothserial_write("om4\r");
	// bluetoothserial_write("fwvers\r");
	setTimeout(bluetoothserial_readhex, 400);
	// setTimeout(bluetoothserial_subscribe, 400);
}

function bluetoothserial_disconnect() {
	console_log("bluetoothserial_disconnect");
	try {
		bluetoothSerial.disconnect(bluetoothserial_disconnect_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_disconnect_success() {
	console_log("bluetoothserial_disconnect_success");
}

function bluetoothserial_write(text) {
	console_log("bluetoothserial_write "+text);
	try {
		bluetoothSerial.write(text, bluetoothserial_write_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_write_success() {
	console_log("bluetoothserial_write_success");
}

function bluetoothserial_write_and_read(text) {
	console_log("bluetoothserial_write_and_read "+text);
	try {
		bluetoothSerial.write(text, bluetoothserial_write_and_read_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_write_and_read_success() {
	console_log("bluetoothserial_write_and_read_success");
	setTimeout(bluetoothserial_read, 200);
}

function bluetoothserial_read() {
	console_log("bluetoothserial_read");
	try {
		bluetoothSerial.read(bluetoothserial_read_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_read_success(data) {
	console_log("bluetoothserial_read_success "+data);
}

function bluetoothserial_readhex() {
	// console_log("bluetoothserial_readhex");
	try {
		bluetoothSerial.read(bluetoothserial_readhex_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_readhex_success(data) {
	// console_log("bluetoothserial_readhex_success "+data);
	// var bytes = stringToBytes2(data);
	
	// bluetoothserial_handle_myontec(createHexString(bytes));
	bluetoothserial_handle_myontec(data);
}

var missedData = "";
var missedCount = 0;
var lastData = 0;
function bluetoothserial_handle_myontec(p_data) {
	var now = new Date().getTime();
	if(mRunning) {
		mbodyClientTime = new Date().getTime();
		mbodyStatus = 2;
		if(missedCount > 0 && missedData != "") { // jariha 2.3.2014
			if(missedCount > 4) {
				var str = "";
				if(mStamp == "") { // jariha 3.6.2014
					myontecData(missedData.trim().split(" "));
					str = "Data {"+missedData+"} "+(p_data.trim().split(" ").length)+" "+(mDataCount-mDataCountOld)+" "+(now-lastData)+"ms\n";
				} else {
					str = "Missed {"+missedData+"} "+(p_data.trim().split(" ").length)+" 0 "+(now-lastData)+"ms\n";
				}
				filewriteappend_debugdata(mSaveStamp, str);
				missedCount = 0;
			} else {
				p_data = missedData + p_data;
			}
			missedData = "";
		}
		
		if(mStamp == "" || p_data.trim().split(" ").length % 8 == 0) {
			missedCount = 0;
			// console_log("myontecData "+p_data.trim().split(" ").length);
			// console_log("myontecData "+p_data);
			myontecData(p_data.trim().split(" "));
			// var str = "Data {"+p_data+"} readed "+p_data.trim().split(" ").length+" bytes. Times i"+(t1-t0)+" + r"+(t2-t1)+" + h"+(t3-t2)+" + d"+(t5-t3)+" = "+(t5-t1)+" ("+(t5-t6)+") ms\n";
			var str = "Data {"+p_data+"} "+(p_data.trim().split(" ").length)+" "+(mDataCount-mDataCountOld)+" "+(now-lastData)+"ms\n";
			filewriteappend_debugdata(mSaveStamp, str);
		} else if(mStamp == "" || (missedCount == 0 && p_data.trim().split(" ").length > 80*3)) { // jariha 14.2.2016
			missedData = p_data.substring(80*3);
			missedCount = 1;
			p_data = p_data.substring(0, 80*3);
			// console_log("myontecData2 "+p_data.trim().split(" ").length);
			// console_log("myontecData2 "+p_data);
			myontecData(p_data.trim().split(" "));
			// var str = "Data {"+p_data+"} readed "+p_data.trim().split(" ").length+" bytes. Times i"+(t1-t0)+" + r"+(t2-t1)+" + h"+(t3-t2)+" + d"+(t5-t3)+" = "+(t5-t1)+" ("+(t5-t6)+") ms\n";
			var str = "Data {"+p_data+"} "+(p_data.trim().split(" ").length)+" "+(mDataCount-mDataCountOld)+" "+(now-lastData)+"ms\n";
			filewriteappend_debugdata(mSaveStamp, str);
		} else {
			var tmpData = p_data;
			missedData += p_data;
			missedCount++;
			// console_log("missedData "+p_data.trim().split(" ").length);
			// console_log("missedData "+p_data);
			// var str = "Stored "+mSaveStamp+" {"+tmpData+"} readed "+tmpData.trim().split(" ").length+" bytes. Times i"+(t1-t0)+" + r"+(t2-t1)+" + h"+(t3-t2)+" + d"+(t5-t3)+" = "+(t5-t1)+" ("+(t5-t6)+") ms\n";
			// filewriteappend_debugdata(mSaveStamp, str);
		}
	
		setTimeout(bluetoothserial_readhex, 400);
	} else {
		// bluetoothserial_unsubscribe();
		// bluetoothserial_clear();
	}
	lastData = now;
}

function bluetoothserial_subscribe() {
	console_log("bluetoothserial_subscribe");
	try {
		bluetoothSerial.subscribeRawData(bluetoothserial_subscribe_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_subscribe_success(data) {
	// if(!document.getElementById("debug").innerHTML.endsWith("bluetoothserial_subscribe_success<br />\n")) console_log("bluetoothserial_subscribe_success");
	var bytes = new Int8Array(data);
	console_log("bluetoothserial_subscribe_success "+bytes.length);
	bluetoothserial_handle_myontec(createHexString(bytes));
	// bluetoothserial_clear();
	/* console_clear();
	try {
		var bytes = new Uint8Array(data);
		var str = "";
		for(var i = 0; i < bytes.length; i++) {
			var val = bytes[i].toString(16);
			if(val.length == 1) val = "0"+val;
			str += val+" ";
		}
		console_log(""+str);
		bluetoothserial_clear();
	} catch(err) {
		console_log(err.Message);
	} */
}

function bluetoothserial_unsubscribe() {
	console_log("bluetoothserial_unsubscribe");
	try {
		bluetoothSerial.unsubscribeRawData(bluetoothserial_unsubscribe_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_unsubscribe_success() {
	console_log("bluetoothserial_unsubscribe_success");
}

function bluetoothserial_clear() {
	// console_log("bluetoothserial_clear");
	try {
		bluetoothSerial.clear(bluetoothserial_clear_success, bluetoothserial_failed);
	} catch(err) {
		console_log(err.Message);
	}
}

function bluetoothserial_clear_success() {
	// console_log("bluetoothserial_clear_success");
}

function ab2str(buf) {
  return String.fromCharCode.apply(null, new Uint16Array(buf));
}

function str2ab(str) {
  var buf = new ArrayBuffer(str.length*2); // 2 bytes for each char
  var bufView = new Uint16Array(buf);
  for (var i=0, strLen=str.length; i<strLen; i++) {
    bufView[i] = str.charCodeAt(i);
  }
  return buf;
}

function createHexString(arr) {
    var result = "";
    for (i in arr) {
        var str = arr[i].toString(16);
        str = str.length == 0 ? "00" :
              str.length == 1 ? "0" + str : 
              str.length == 2 ? str :
              ""; // str.substring(str.length-2, str.length);
        if(str != "") result += " "+str;
    }
    return result;
}
function stringToBytes2 ( str ) {
  var ch, st, re = [];
  for (var i = 0; i < str.length; i++ ) {
    ch = str.charCodeAt(i);  // get char 
    st = [];                 // set up "stack"
    /* do {
      st.push( ch & 0xFF );  // push byte to stack
      ch = ch >> 8;          // shift value down by 1 byte
    } while ( ch ); */
	if(ch >> 8) {
		st.push( ch & 0xFF );
	} else {
		st.push( ch & 0xFF );
	}
    // add stack contents to result
    // done because chars have "wrong" endianness
	re = re.concat( st.reverse() );
  }
  // return an array of bytes
  return re;
}

// Log
/* function console_log(msg) {
    if(useDebug) {
        if(document.getElementById("debug").innerHTML.length > 3000) document.getElementById("debug").innerHTML = "";
        document.getElementById("debug").innerHTML += msg+"<br />\n";
    }
}

function console_clear() {
    document.getElementById("debug").innerHTML = "";
} */
