var useSound = false;

var balanceCounter0 = 6;
var balanceCounter1 = 0; // + right, - left
var balanceLimit1 = 3;
var balanceCounter2 = 0; // + right, - left
var balanceLimit2 = 6;

var muscleLoadCounter0 = 6;
var muscleLoadCounter = 0;

var lastCall = 0;

function checkMuscleLimits(arr) {
    // leftQ, rightQ, leftH, rightH
    
    var now = new Date().getTime();
    if(now-1000 > lastCall) {
        lastCall = now;
        var total = arr[0]+arr[1]+arr[2]+arr[3];
        var balance = (parseInt(arr[0])+parseInt(arr[2]))/(total)*100;
        var muscleLoad = total/mlScale;
        var soundDone = false;
        
        if(muscleLoad > 50) {
        if(balance > 50+balanceLimit1) {
            if(balanceCounter1 <= 0) {
                balanceCounter1--;
            } else {
                balanceCounter1 = 0;
            }
            balanceCounter0 = 6;
        } else if(balance < 50-balanceLimit1) {
            if(balanceCounter1 >= 0) {
                balanceCounter1++;
             } else {
                balanceCounter1 = 0;
            }
            balanceCounter0 = 6;
        } else {
            if(balanceCounter1 <= -5 || balanceCounter1 >= 5) {
                // playSound('Information', 'audio/en_balance_good.mp3', 'Your muscle balance is good.');
                balanceCounter0 = 0;
            }
            if(balanceCounter0++ == 5) {
                playSound('Information', 'audio/en_balance_good.mp3', 'Your muscle balance is good.');
                soundDone = true;
            }
            balanceCounter1 = 0;
        }
        
        if(balance > 50+balanceLimit2) {
            if(balanceCounter2 <= 0) {
                balanceCounter2--;
            } else {
                balanceCounter2 = 0;
            }
        } else if(balance < 50-balanceLimit2) {
            if(balanceCounter2 >= 0) {
                balanceCounter2++;
            } else {
                balanceCounter2 = 0;
            }
        } else {
            balanceCounter2 = 0;
        }
        } else {
            balanceCounter1 = 0;
            balanceCounter2 = 0;
        }
        
        if(muscleLoad > muscleScale) {
            muscleLoadCounter++;
            muscleLoadCounter0 = 6;
        } else {
            if(muscleLoadCounter >= 5) {
                // playSound('Information', 'audio/en_muscleload_below.mp3', 'Your are now below your muscle load threshold.');
                muscleLoadCounter0 = 0;
            }
            if(muscleLoadCounter0++ == 5) {
                playSound('Information', 'audio/en_muscleload_below.mp3', 'Your are now below your muscle load threshold.');
                soundDone = true;
            }
            muscleLoadCounter = 0;
        }
        
        if(balanceCounter2 == -5 || balanceCounter2 == -15 || balanceCounter2 == -45 || balanceCounter2 == -135) {
            playSound('Alert', 'audio/en_balance_strongly_left.mp3', 'Your muscle balance is focused strongly on the left.');
            soundDone = true;
        } else if(balanceCounter2 == 5 || balanceCounter2 == 15 || balanceCounter2 == 45 || balanceCounter2 == 135) {
            playSound('Alert', 'audio/en_balance_strongly_right.mp3', 'Your muscle balance is focused strongly on the right.');
            soundDone = true;
        } else if(balanceCounter2 > -5 && (balanceCounter1 == -5 || balanceCounter1 == -15 || balanceCounter1 == -45 || balanceCounter1 == -135)) {
            playSound('Notification', 'audio/en_balance_slightly_left.mp3', 'Your muscle balance is slightly on the left.');
            soundDone = true;
        } else if(balanceCounter2 < 5 && (balanceCounter1 == 5 || balanceCounter1 == 15 || balanceCounter1 == 45 || balanceCounter1 == 135)) {
            playSound('Notification', 'audio/en_balance_slightly_right.mp3', 'Your muscle balance is slightly on the right.');
            soundDone = true;
        }
        
        if(muscleLoadCounter == 5) {
            if(soundDone) {
                muscleLoadCounter--;
                muscleLoadCounter--;
            } else {
                playSound('Notification', 'audio/en_muscleload_exceeded.mp3', 'Your have exceeded your muscle load threshold.');
            }
        } else if(muscleLoadCounter == 15 || muscleLoadCounter == 45 || muscleLoadCounter == 135) {
            if(soundDone) {
                muscleLoadCounter--;
                muscleLoadCounter--;
            } else {
                playSound('Alert', 'audio/en_muscleload_above.mp3', 'Your muscle load is above the threshold.');
            }
        }
        
        if(useDebug) document.getElementById("debug4").innerHTML = "balanceCounter1: "+balanceCounter1+", balanceCounter2: "+balanceCounter2+", muscleLoadCounter: "+muscleLoadCounter;
    }
}

function playSound(type, filename, txt) {
    if(useSound) {
        var myMedia = new Media(filename);
        myMedia.play();
        showDialog(type, txt, 4000);
    }
    console_log(type+": "+txt);
}